<?php

namespace Drupal\lgp\Commands;

use Drush\Commands\DrushCommands;

class LgpCommands extends DrushCommands {

  /**
   * Print to stdout the output of lgp.log
   *
   * @command lg-console
   *
   * @usage lgc
   *   Print the output of lgp.log
   *
   * @aliases lgc
   *
   * @validate-module-enabled lgp
   */
  public function lgc($var = NULL) {
    $filepath = lgp_get_temp_dir() . '/' . LGP_LOG_FILENAME;
    $file = fopen($filepath, 'r');
    if (!$file) {
      throw new \RuntimeException("Unable to open the file: $filepath");
    }

    $seekFromEnd = -200; // Start from the last 200 bytes
    fseek($file, $seekFromEnd, SEEK_END);

    while (true) {
      clearstatcache(true, $filepath);
      $currentSize = filesize($filepath);

      if ($currentSize < ftell($file)) {
        fseek($file, 0, SEEK_SET); // File was truncated, start from the beginning
      }

      while ($line = fgets($file)) {
        echo $line;
      }

      // Move the file pointer to the current end for the next iteration
      fseek($file, 0, SEEK_END);

      usleep(100000); // update every 10th of a second
    }

    fclose($file);
  }
}
